"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-nocheck
var api_config_1 = require("../configs/api-config");
var actions_1 = require("./actions");
var rest_helper_1 = require("./rest-helper");
var path = require("path");
require("dotenv").config({ path: ".env.platform" });
var testPlanId;
var testSuiteId;
var testCaseId;
var _testPointId;
var _testRunId;
var testplanData;
var AzureIntegration = /** @class */ (function () {
    function AzureIntegration() {
    }
    AzureIntegration.getTestPlandetails = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var startingDir, targetFileName, rootDirectory, rootPath, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        startingDir = __dirname;
                        targetFileName = 'tsconfig.json';
                        return [4 /*yield*/, actions_1.default.findFilePath(startingDir, targetFileName)];
                    case 1:
                        rootDirectory = _a.sent();
                        rootPath = path.resolve(rootDirectory, '../');
                        return [4 /*yield*/, actions_1.default.ReadFileContent(filePath, rootPath)];
                    case 2:
                        data = _a.sent();
                        testplanData = JSON.parse(data);
                        try {
                            testPlanId = testplanData.testPlanId;
                            testSuiteId = testplanData.testSuiteId;
                            testCaseId = testplanData.testCaseId;
                        }
                        catch (error) {
                            console.warn("\nUnable to retrive the full test plan meta data. Please ensure that you have a valid JSON with test plan id, test suite id, and test case id.");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    AzureIntegration.getTestPointId = function () {
        return __awaiter(this, void 0, void 0, function () {
            var values, testPoint, response, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        values = Object.values(testplanData);
                        if (!(values.length !== 0)) return [3 /*break*/, 5];
                        return [4 /*yield*/, rest_helper_1.default.sendGETRequest("/".concat(process.env.ORGANISATION, "/").concat(process.env.PROJECT, "/_apis/test/plans/").concat(testPlanId, "/suites/").concat(testSuiteId, "/points?testCaseId=").concat(testCaseId, "&api-version=5.0"))];
                    case 1:
                        testPoint = _a.sent();
                        response = void 0;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, testPoint.json()];
                    case 3:
                        response = _a.sent();
                        _testPointId = response.value[0].id;
                        return [2 /*return*/, _testPointId];
                    case 4:
                        error_1 = _a.sent();
                        if (testPoint.status() == 401) {
                            console.log('\x1b[33m%s\x1b[0m', 'WARN: ' + 'ADO was unable to authenticate you. Please ensure that your PAT token is valid');
                        }
                        if (testPoint.status() == 404) {
                            console.log('\x1b[33m%s\x1b[0m', 'WARN: ' + "\nUnable to retrieve test point ID. \nPlease make sure that your test plain ID, test suite ID, and test case ID are valid.}");
                            console.warn();
                        }
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    AzureIntegration.createTestRun = function (testRunName) {
        return __awaiter(this, void 0, void 0, function () {
            var restResponse, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!_testPointId) return [3 /*break*/, 3];
                        return [4 /*yield*/, api_config_1.apiContext.post("/".concat(process.env.ORGANISATION, "/").concat(process.env.PROJECT, "/_apis/test/runs?api-version=5.0"), {
                                data: {
                                    name: "Automated Test" + Date.now(),
                                    plan: { id: testPlanId },
                                    pointIds: [_testPointId],
                                },
                            })];
                    case 1:
                        restResponse = _a.sent();
                        return [4 /*yield*/, restResponse.json()];
                    case 2:
                        response = _a.sent();
                        _testRunId = response.id;
                        return [2 /*return*/, _testRunId];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    AzureIntegration.updateTestResults = function (outcome) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!_testRunId) return [3 /*break*/, 2];
                        return [4 /*yield*/, api_config_1.apiContext.patch("/".concat(process.env.ORGANISATION, "/").concat(process.env.PROJECT, "/_apis/test/runs/").concat(_testRunId, "/results?api-version=5.1-preview.6"), {
                                data: [{ id: 100000, outcome: outcome, state: "Completed", comment: "Execution Successful" }],
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    AzureIntegration.attachScreenShot = function (stream) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, api_config_1.apiContext.post("/".concat(process.env.ORGANISATION, "/").concat(process.env.PROJECT, "/_apis/test/runs/").concat(_testRunId, "/results/100000/attachments?api-version=5.0-preview.1"), {
                            data: {
                                stream: stream,
                                fileName: "screenshot.png",
                                comment: "Screenshot captured from failed scenario",
                                attachmentType: "GeneralAttachment",
                            },
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AzureIntegration.publishTestResults = function (filePath, outcome) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AzureIntegration.getTestPlandetails(filePath)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, AzureIntegration.getTestPointId()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, AzureIntegration.createTestRun()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, AzureIntegration.updateTestResults(outcome)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return AzureIntegration;
}());
exports.default = AzureIntegration;
